// Sensony
//
// While "A" is displayed,
// press left / right to adjust the speed (+/-)
// press up / down to adjust the sound (+/-)
// press A to start
//
// Ingame controls:
// UP    = up,left
// RIGHT = up,right
// LEFT  = down,left
// DOWN  = down,rigt
//
// 2009 by Yen :: mail@sebastiansester.de


#include <gamekit_2_1.h>
#include <avr/pgmspace.h>

int n[4] = { 5000,5200,5400,5600 };
int wait = 0;
int point = 0;
int counter = 0;
int seq[30] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
int irand = 0;
int volume = 1;
int speed = 500;

const uint8_t map1[5][7] PROGMEM = {
  0 ,15,15,15,15,15,0 ,
  0 ,15,0 ,0 ,0 ,15,0 ,
  0 ,15,15,15,15,15,0 ,
  0 ,15,0 ,0 ,0 ,15,0 ,
  0 ,15,0 ,0 ,0 ,15,0 ,
};

const uint8_t map2[5][7] PROGMEM = {
  0 ,0 ,0 ,19,0 ,0 ,0 ,
  0 ,0 ,0 ,19,0 ,0 ,0 ,
  19,19,19,19,19,19,19,
  0 ,0 ,0 ,19,0 ,0 ,0 ,
  0 ,0 ,0 ,19,0 ,0 ,0 ,
};

void lighten(int a, int b = 0) {
  int f[8] = {0,0,0,4,3,0,3,4};
  int j;
  int k;
  if(a > 3)
    a = 3;
  if(a < -2)
    a = 0;
  if(a > 0)
    a *= 2;
  j = 0;
  if(b < 1) {
    while(j < 5) {
      k = 0;
      while(k < 7) {
        if(k != 3 && j != 2) {
          if(a >= 0 && j >= f[a] && j <= (f[a] + 1) && k >= f[a+1] && k <= (f[a+1] + 2))
            gamekit.set_pixel(j,k,15);
          else {
            if(a == -2)
              gamekit.set_pixel(j,k,15);
            else
              gamekit.set_pixel(j,k,0);
          }
        }
        k++;
      }
      j++;
    }
  }
  if(a >= 0)
    if(volume == 1)
      gamekit.play_tone(n[a/2],speed,SILENT);
    else if(volume == 2)
      gamekit.play_tone(n[a/2],speed,LOUD);
    else
      delay(speed);
}

void game_over() {
  if(volume == 1) {
    gamekit.play_tone(3200,100,SILENT);
    gamekit.play_tone(3400,100,SILENT);
    gamekit.play_tone(3600,100,SILENT);
    gamekit.play_tone(4000,100,SILENT);
    gamekit.play_tone(4000,600,SILENT);
    gamekit.play_tone(3500,600,SILENT);
    gamekit.play_tone(3000,600,SILENT);
    gamekit.play_tone(2800,800,SILENT);
  } else if(volume == 2) {
    gamekit.play_tone(3200,100,LOUD);
    gamekit.play_tone(3400,100,LOUD);
    gamekit.play_tone(3600,100,LOUD);
    gamekit.play_tone(4000,100,LOUD);
    gamekit.play_tone(4000,600,LOUD);
    gamekit.play_tone(3500,600,LOUD);
    gamekit.play_tone(3000,600,LOUD);
    gamekit.play_tone(2800,800,LOUD);    
  }
}

void game_win() {
  if(volume == 1) {
    gamekit.play_tone(1000,300,SILENT);
    gamekit.play_tone(1500,600,SILENT);
    gamekit.play_tone(1000,300,SILENT);
    gamekit.play_tone(1500,600,SILENT);
    gamekit.play_tone(1000,300,SILENT);
    gamekit.play_tone(1500,1000,SILENT);
  } else if(volume == 2) {
    gamekit.play_tone(1000,300,LOUD);
    gamekit.play_tone(1500,600,LOUD);
    gamekit.play_tone(1000,300,LOUD);
    gamekit.play_tone(1500,600,LOUD);
    gamekit.play_tone(1000,300,LOUD);
    gamekit.play_tone(1500,1000,LOUD);
  }
}

void play_begin() {
  boolean a = false;
  gamekit.load_image(map1);
  while(!gamekit.button_pressed(butt_FUNCA)) {
    if(gamekit.button_pressed(butt_UP)) {
      a = true;
      if(volume < 2)
        volume++;
      irand++;
    }
    else if(gamekit.button_pressed(butt_DOWN)) {
      a = true;
      if(volume > 0)
        volume--;
      irand++;
    }
    else if(gamekit.button_pressed(butt_LEFT)) {
      a = true;
      if(speed > 200)
        speed = speed - 100;
      irand++;
    }
    else if(gamekit.button_pressed(butt_RIGHT)) {
      a = true;
      if(speed < 700)
        speed = speed + 100;
      irand++;
    }
    if(a == true) {
      irand++;
      lighten(0,1);
      delay(50);
      lighten(0,1);
      a = false;
    }    
    irand++;
  }
  gamekit.load_image(map2);
  randomSeed(irand + 10);
  point = 29;
  while(point > 0) {
    seq[point] = random(0,4);
    point--;
  }
  seq[0] = random(0,4);
  lighten(-1);
  delay(200);
  lighten(-2);
  delay(200);
  lighten(-1);
  delay(200);
  lighten(-2);
  delay(200);
  lighten(-1);
  delay(1000);
  wait = 0;
}

void setup() {
  gamekit.Begin();
  gamekit.load_image(map2);
  lighten(0);
  delay(100);
  lighten(1);
  delay(100);
  lighten(2);
  delay(100);
  lighten(3);
  delay(100);
  lighten(-1);
  play_begin();
}

void loop() {
  uint32_t buttons;
  if(wait) {
    int buttons[5] = {0,0,0,0,0};
    buttons[0] = gamekit.button_pressed(butt_UP);
    buttons[1] = gamekit.button_pressed(butt_RIGHT);
    buttons[2] = gamekit.button_pressed(butt_LEFT);
    buttons[3] = gamekit.button_pressed(butt_DOWN);
    buttons[4] = buttons[0] + buttons[1] + buttons[2] + buttons[3];
    if(buttons[seq[counter]] == 1 && buttons[4] == 1) {
      lighten(seq[counter]);
      lighten(-1);
      counter++;
      if(counter == point) {
        if(counter == 29) {
          game_win();
          play_begin();
        }
        else {
          wait = 0;
          delay(200);
        }
      }
    }
    else if(buttons[4] == 1) {
      game_over();
      play_begin();
    }
    delay(20);
  } else {
    point++;
    counter = 0;
    while(counter < point) {
      lighten(seq[counter]);
      lighten(-1);
      delay(50);
      counter++;
    } 
    lighten(-1);
    counter = 0;
    wait = 1;
  }
}
